ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.40 by greg, Sat Oct 13 20:15:43 2012 UTC vs.
Revision 2.68 by greg, Fri Sep 16 20:01:29 2016 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-s \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz,$cph);
17 > my ($curphase, $recovery);
18 > if ($#ARGV == 1 && "$ARGV[0]" =~ /^-rec/) {
19 >        $td = $ARGV[1];
20 >        open(MYAVH, "< $td/savedARGV.txt") or die "$td: invalid path\n";
21 >        @ARGV = <MYAVH>;
22 >        close MYAVH;
23 >        chomp @ARGV;
24 >        if (open(MYPH, "< $td/phase.txt")) {
25 >                while (<MYPH>) {
26 >                        chomp($recovery = $_);
27 >                }
28 >                close MYPH;
29 >        }
30 > } elsif ($windoz) {
31 >        my $tmploc = `echo \%TMP\%`;
32 >        chomp $tmploc;
33 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
34 > } else {
35 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
36 >        chomp $td;
37 > }
38 > if ($windoz) {
39 >        $radscn = "$td\\device.rad";
40 >        $mgfscn = "$td\\device.mgf";
41 >        $octree = "$td\\device.oct";
42 >        $fsender = "$td\\fsender.rad";
43 >        $bsender = "$td\\bsender.rad";
44 >        $receivers = "$td\\receivers.rad";
45 >        $facedat = "$td\\face.dat";
46 >        $behinddat = "$td\\behind.dat";
47 >        $tf = "$td\\tf.dat";
48 >        $rf = "$td\\rf.dat";
49 >        $tb = "$td\\tb.dat";
50 >        $rb = "$td\\rb.dat";
51 >        $tfx = "$td\\tfx.dat";
52 >        $rfx = "$td\\rfx.dat";
53 >        $tbx = "$td\\tbx.dat";
54 >        $rbx = "$td\\rbx.dat";
55 >        $tfz = "$td\\tfz.dat";
56 >        $rfz = "$td\\rfz.dat";
57 >        $tbz = "$td\\tbz.dat";
58 >        $rbz = "$td\\rbz.dat";
59 >        $cph = "$td\\phase.txt";
60 >        $rmtmp = "rd /S /Q $td";
61 > } else {
62 >        $radscn = "$td/device.rad";
63 >        $mgfscn = "$td/device.mgf";
64 >        $octree = "$td/device.oct";
65 >        $fsender = "$td/fsender.rad";
66 >        $bsender = "$td/bsender.rad";
67 >        $receivers = "$td/receivers.rad";
68 >        $facedat = "$td/face.dat";
69 >        $behinddat = "$td/behind.dat";
70 >        $tf = "$td/tf.dat";
71 >        $rf = "$td/rf.dat";
72 >        $tb = "$td/tb.dat";
73 >        $rb = "$td/rb.dat";
74 >        $tfx = "$td/tfx.dat";
75 >        $rfx = "$td/rfx.dat";
76 >        $tbx = "$td/tbx.dat";
77 >        $rbx = "$td/rbx.dat";
78 >        $tfz = "$td/tfz.dat";
79 >        $rfz = "$td/rfz.dat";
80 >        $tbz = "$td/tbz.dat";
81 >        $rbz = "$td/rbz.dat";
82 >        $cph = "$td/phase.txt";
83 >        $rmtmp = "rm -rf $td";
84 > }
85   my @savedARGV = @ARGV;
86 + my $rfluxmtx = "rfluxmtx -ab 5 -ad 700 -lw 3e-6";
87 + my $wrapper = "wrapBSDF";
88   my $tensortree = 0;
89   my $ttlog2 = 4;
90   my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
91   my $mgfin = 0;
92   my $geout = 1;
93   my $nproc = 1;
94 + my $docolor = 0;
95   my $doforw = 0;
96   my $doback = 1;
97   my $pctcull = 90;
98 < my $gunit = "Meter";
98 > my $gunit = "meter";
99 > my $curspec = "Visible";
100   my @dim;
101   # Get options
102   while ($#ARGV >= 0) {
103          if ("$ARGV[0]" =~ /^[-+]m/) {
104                  $mgfin = ("$ARGV[0]" =~ /^\+/);
105          } elsif ("$ARGV[0]" eq "-r") {
106 <                $rtargs = "$rtargs $ARGV[1]";
106 >                $rfluxmtx .= " $ARGV[1]";
107                  shift @ARGV;
108          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
109                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 40 | Line 112 | while ($#ARGV >= 0) {
112                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
113                  }
114                  shift @ARGV;
115 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
116 +                $docolor = ("$ARGV[0]" =~ /^\+/);
117          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
118                  $doforw = ("$ARGV[0]" =~ /^\+/);
119          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
# Line 47 | Line 121 | while ($#ARGV >= 0) {
121          } elsif ("$ARGV[0]" eq "-t") {
122                  # Use value < 0 for rttree_reduce bypass
123                  $pctcull = $ARGV[1];
124 +                if ($pctcull >= 100) {
125 +                        die "Illegal -t culling percentage, must be < 100\n";
126 +                }
127                  shift @ARGV;
128          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
129                  $tensortree = substr($ARGV[0], 2, 1);
130                  $ttlog2 = $ARGV[1];
131                  shift @ARGV;
132 +        } elsif ("$ARGV[0]" eq "-s") {
133 +                $wrapper .= " -f \"$ARGV[1]\"";
134 +                shift @ARGV;
135 +        } elsif ("$ARGV[0]" eq "-W") {
136 +                $wrapper .= " -W";
137          } elsif ("$ARGV[0]" eq "-c") {
138                  $nsamp = $ARGV[1];
139                  shift @ARGV;
# Line 71 | Line 153 | while ($#ARGV >= 0) {
153   }
154   # Check that we're actually being asked to do something
155   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
156 < # Get scene description and dimensions
157 < my $radscn = "$td/device.rad";
158 < my $mgfscn = "$td/device.mgf";
159 < my $octree = "$td/device.oct";
160 < if ( $mgfin ) {
161 <        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
162 <        die "Could not load MGF input\n" if ( $? );
163 <        system "mgf2rad $mgfscn > $radscn";
164 < } else {
165 <        system "xform -e @ARGV > $radscn";
166 <        die "Could not load Radiance input\n" if ( $? );
167 <        system "rad2mgf $radscn > $mgfscn" if ( $geout );
156 > $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
157 > $wrapper .= " -u $gunit";
158 > if ( !defined $recovery ) {
159 >        # Issue warning for unhandled reciprocity case
160 >        print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
161 >                        ($tensortree==3 && !($doforw && $doback));
162 >        # Get scene description
163 >        if ( $mgfin ) {
164 >                system "mgf2rad @ARGV > $radscn";
165 >                die "Could not load MGF input\n" if ( $? );
166 >        } else {
167 >                system "xform -e @ARGV > $radscn";
168 >                die "Could not load Radiance input\n" if ( $? );
169 >        }
170   }
171 < if ($#dim != 5) {
171 > if ( $#dim != 5 ) {
172          @dim = split ' ', `getbbox -h $radscn`;
173   }
174 < print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
175 < # Add receiver surfaces (rectangular)
176 < my $fmodnm="receiver_face";
177 < my $bmodnm="receiver_behind";
178 < open(RADSCN, ">> $radscn");
95 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99 < close RADSCN;
100 < # Generate octree
101 < system "oconv -w $radscn > $octree";
102 < die "Could not compile scene\n" if ( $? );
103 < # Output XML prologue
104 < print
105 < '<?xml version="1.0" encoding="UTF-8"?>
106 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 < ';
108 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 < print
110 < '<WindowElementType>System</WindowElementType>
111 < <FileType>BSDF</FileType>
112 < <Optical>
113 < <Layer>
114 <        <Material>
115 <                <Name>Name</Name>
116 <                <Manufacturer>Manufacturer</Manufacturer>
117 < ';
118 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 < print "\t\t<DeviceType>Other</DeviceType>\n";
122 < print " </Material>\n";
123 < # Output MGF description if requested
124 < if ( $geout ) {
125 <        print "\t<Geometry format=\"MGF\">\n";
126 <        print "\t\t<MGFblock unit=\"$gunit\">\n";
127 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
128 <        open(MGFSCN, "< $mgfscn");
129 <        while (<MGFSCN>) { print $_; }
130 <        close MGFSCN;
131 <        print "xf\n";
132 <        print "\t\t</MGFblock>\n";
133 <        print "\t</Geometry>\n";
174 > die "Device entirely inside room!\n" if ( $dim[4] >= 0 );
175 > if ( $dim[5] > 1e-5 ) {
176 >        print STDERR "Warning: Device extends into room\n";
177 > } elsif ( $dim[5]*$dim[5] > .01*($dim[1]-$dim[0])*($dim[3]-$dim[2]) ) {
178 >        print STDERR "Warning: Device far behind Z==0 plane\n";
179   }
180 < # Set up surface sampling
181 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
182 < my $ny = int($nsamp/$nx + .5);
183 < $nsamp = $nx * $ny;
180 > # Assume Zmax==0 to derive thickness so pkgBSDF will work
181 > $wrapper .= ' -f "t=' . (-$dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
182 >                ';h=' . ($dim[3] - $dim[2]) . '"';
183 > $wrapper .= " -g $mgfscn" if ( $geout );
184 > # Calculate CIE (u',v') from Radiance RGB:
185 > my $CIEuv =     'Xi=.5141*Ri+.3239*Gi+.1620*Bi;' .
186 >                'Yi=.2651*Ri+.6701*Gi+.0648*Bi;' .
187 >                'Zi=.0241*Ri+.1229*Gi+.8530*Bi;' .
188 >                'den=Xi+15*Yi+3*Zi;' .
189 >                'uprime=4*Xi/den;vprime=9*Yi/den;' ;
190 > my $FEPS = 1e-5;
191   my $ns = 2**$ttlog2;
192 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
192 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
193 > my $ny = int($nsamp/$nx + 1);
194 > $nsamp = $nx * $ny;
195 > $rfluxmtx .= " -n $nproc -c $nsamp";
196 > if ( !defined $recovery ) {
197 >        open(MYAVH, "> $td/savedARGV.txt");
198 >        foreach (@savedARGV) {
199 >                print MYAVH "$_\n";
200 >        }
201 >        close MYAVH;
202 >        # Generate octree
203 >        system "oconv -w $radscn > $octree";
204 >        die "Could not compile scene\n" if ( $? );
205 >        # Add MGF description if requested
206 >        if ( $geout ) {
207 >                open(MGFSCN, "> $mgfscn");
208 >                printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
209 >                close MGFSCN;
210 >                if ( $mgfin ) {
211 >                        system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
212 >                } else {
213 >                        system "rad2mgf $radscn >> $mgfscn";
214 >                }
215 >                open(MGFSCN, ">> $mgfscn");
216 >                print MGFSCN "xf\n";
217 >                close MGFSCN;
218 >        }
219 >        # Create receiver & sender surfaces (rectangular)
220 >        open(RADSCN, "> $receivers");
221 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=-sc$ns\n" : "h=-kf\n");
222 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$facedat\n\n";
223 >        print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
224 >        print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
225 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=+sc$ns\n" : "h=+kf\n");
226 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$behinddat\n\n";
227 >        print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
228 >        print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
229 >        close RADSCN;
230 >        # Prepare sender surfaces
231 >        if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
232 >                open (RADSCN, "> $fsender");
233 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=-sc$ns\n\n" : "h=-kf\n\n");
234 >                print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
235 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[4]-$FEPS;
236 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[4]-$FEPS;
237 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[4]-$FEPS;
238 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[4]-$FEPS;
239 >                close RADSCN;
240 >                open (RADSCN, "> $bsender");
241 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=+sc$ns\n\n" : "h=+kf\n\n");
242 >                print RADSCN "void polygon bwd_sender\n0\n0\n12\n";
243 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[5]+$FEPS;
244 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[5]+$FEPS;
245 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[5]+$FEPS;
246 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[5]+$FEPS;
247 >                close RADSCN;
248 >        }
249 >        print STDERR "Recover using: $0 -recover $td\n";
250 > }
251 > # Open unbuffered progress file
252 > open(MYPH, ">> $td/phase.txt");
253 > {
254 >        my $ofh = select MYPH;
255 >        $| = 1;
256 >        select $ofh;
257 > }
258 > $curphase = 0;
259   # Create data segments (all the work happens here)
260   if ( $tensortree ) {
261          do_tree_bsdf();
262   } else {
263          do_matrix_bsdf();
264   }
265 < # Output XML epilogue
266 < print
267 < '</Layer>
268 < </Optical>
151 < </WindowElement>
152 < ';
265 > # Output XML
266 > # print STDERR "Running: $wrapper\n";
267 > system "$wrapper -C \"Created by: genBSDF @savedARGV\"";
268 > die "Could not wrap BSDF data\n" if ( $? );
269   # Clean up temporary files and exit
270 < exec("rm -rf $td");
270 > exec $rmtmp;
271  
272 < #-------------- End of main program segment --------------#
272 > #============== End of main program segment ==============#
273  
274 + # Function to determine if next phase should be skipped or recovered
275 + sub do_phase {
276 +        $curphase++;
277 +        if (defined $recovery) {
278 +                if ($recovery > $curphase) { return 0; }
279 +                if ($recovery == $curphase) { return -1; }
280 +        }
281 +        print MYPH "$curphase\n";
282 +        return 1;
283 + }
284 +
285   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
286   sub do_tree_bsdf {
160 # Shirley-Chiu mapping from unit square to disk
161 $sq2disk = '
162 in_square_a = 2*in_square_x - 1;
163 in_square_b = 2*in_square_y - 1;
164 in_square_rgn = if(in_square_a + in_square_b,
165                        if(in_square_a - in_square_b, 1, 2),
166                        if(in_square_b - in_square_a, 3, 4));
167 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
168                        -in_square_a, -in_square_b);
169 out_disk_phi = PI/4 * select(in_square_rgn,
170                                in_square_b/in_square_a,
171                                2 - in_square_a/in_square_b,
172                                4 + in_square_b/in_square_a,
173                                if(in_square_b*in_square_b,
174                                        6 - in_square_a/in_square_b, 0));
175 Dx = out_disk_r*cos(out_disk_phi);
176 Dy = out_disk_r*sin(out_disk_phi);
177 Dz = sqrt(1 - out_disk_r*out_disk_r);
178 ';
179 # Shirley-Chiu mapping from unit disk to square
180 $disk2sq = '
181 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
182 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
183 in_disk_phi = norm_radians(atan2(Dy, Dx));
184 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
185 out_square_a = select(in_disk_rgn,
186                        in_disk_r,
187                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
188                        -in_disk_r,
189                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
190 out_square_b = select(in_disk_rgn,
191                        in_disk_phi*in_disk_r/(PI/4),
192                        in_disk_r,
193                        (PI - in_disk_phi)*in_disk_r/(PI/4),
194                        -in_disk_r);
195 out_square_x = (out_square_a + 1)/2;
196 out_square_y = (out_square_b + 1)/2;
197 ';
198 # Announce ourselves in XML output
199 print "\t<DataDefinition>\n";
200 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
201 print "\t</DataDefinition>\n";
287  
288 < # Start rcontrib processes for compute each side
289 < do_tree_rtcontrib(0) if ( $doback );
290 < do_tree_rtcontrib(1) if ( $doforw );
288 >        # Run rfluxmtx processes to compute each side
289 >        do_ttree_dir(0) if ( $doback );
290 >        do_ttree_dir(1) if ( $doforw );
291  
292   }       # end of sub do_tree_bsdf()
293  
294 < # Run rcontrib process to generate tensor tree samples
295 < sub do_tree_rtcontrib {
294 > # Call rfluxmtx and process tensor tree BSDF for the given direction
295 > sub do_ttree_dir {
296          my $forw = shift;
297 <        my $matargs = "-m $bmodnm";
298 <        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
299 <        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
300 <                "-e '$disk2sq' -bn '$ns*$ns' " .
216 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
217 <                "-o $td/%s.flt $matargs $octree";
297 >        my $r = do_phase();
298 >        if (!$r) { return; }
299 >        $r = ($r < 0) ? " -r" : "";
300 >        my $cmd;
301          if ( $tensortree == 3 ) {
302                  # Isotropic BSDF
303                  my $ns2 = $ns / 2;
304 <                $cmd = "cnt $ns2 $ny $nx " .
305 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
306 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
307 <                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
308 <                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
309 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
310 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
311 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
312 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
313 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
314 <                        "| $cmd";
304 >                if ($windoz) {
305 >                        $cmd = "cnt $ns2 $ny $nx " .
306 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
307 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
308 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
309 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
310 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
311 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
312 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
313 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
314 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
315 >                                "| $rfluxmtx$r -fa -y $ns2 - $receivers -i $octree";
316 >                } else {
317 >                        $cmd = "cnt $ns2 $ny $nx " .
318 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
319 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
320 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
321 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
322 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
323 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
324 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
325 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
326 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
327 >                                "| $rfluxmtx$r -h -ff -y $ns2 - $receivers -i $octree";
328 >                }
329          } else {
330                  # Anisotropic BSDF
331 <                # Sample area vertically to improve load balance, since
332 <                # shading systems usually have bilateral symmetry (L-R)
333 <                $cmd = "cnt $ns $ns $ny $nx " .
334 <                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
335 <                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
336 <                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
240 <                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
241 <                        "-e 'in_square_x=(\$1+r1)/$ns' " .
242 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
243 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
244 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
245 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
246 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
247 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
248 <                        "| $cmd";
331 >                my $sender = ($bsender,$fsender)[$forw];
332 >                if ($windoz) {
333 >                        $cmd = "$rfluxmtx$r -fa $sender $receivers -i $octree";
334 >                } else {
335 >                        $cmd = "$rfluxmtx$r -h -ff $sender $receivers -i $octree";
336 >                }
337          }
338 < # print STDERR "Starting: $cmd\n";
339 <        system "$cmd" || die "Failure running rcontrib";
338 >        # print STDERR "Starting: $cmd\n";
339 >        system $cmd;
340 >        die "Failure running rfluxmtx" if ( $? );
341          ttree_out($forw);
342 < }       # end of do_tree_rtcontrib()
342 > }       # end of do_ttree_dir()
343  
344 < # Simplify and output tensor tree results
344 > # Simplify and store tensor tree results
345   sub ttree_out {
346          my $forw = shift;
347 <        my $side = ("Back","Front")[$forw];
348 <        my $cmd;
349 < # Only output one transmitted anisotropic distribution, preferring backwards
350 < if ( !$forw || !$doback || $tensortree==3 ) {
351 < print
352 < '       <WavelengthData>
353 <                <LayerNumber>System</LayerNumber>
265 <                <Wavelength unit="Integral">Visible</Wavelength>
266 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
267 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
268 <                <WavelengthDataBlock>
269 < ';
270 < print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
271 < print
272 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
273 <                        <ScatteringDataType>BTDF</ScatteringDataType>
274 <                        <ScatteringData>
275 < ';
276 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
278 < if ($pctcull >= 0) {
279 <        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
280 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
281 <        system "$cmd" || die "Failure running rttree_reduce";
282 < } else {
283 <        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
284 <        print "{\n";
285 <        system "$cmd" || die "Failure running rcalc";
286 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
287 <                print "0\n";
347 >        my ($refldat,$transdat);
348 >        if ( $forw ) {
349 >                $transdat = $facedat;
350 >                $refldat = $behinddat;
351 >        } else {
352 >                $transdat = $behinddat;
353 >                $refldat = $facedat;
354          }
355 <        print "}\n";
356 < }
357 < print
358 < '                       </ScatteringData>
359 <                </WavelengthDataBlock>
360 <        </WavelengthData>
361 < ';
362 < }
297 < # Output reflection
298 < print
299 < '       <WavelengthData>
300 <                <LayerNumber>System</LayerNumber>
301 <                <Wavelength unit="Integral">Visible</Wavelength>
302 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
303 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
304 <                <WavelengthDataBlock>
305 < ';
306 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
307 < print
308 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
309 <                        <ScatteringDataType>BTDF</ScatteringDataType>
310 <                        <ScatteringData>
311 < ';
312 < $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
313 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
314 < if ($pctcull >= 0) {
315 <        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
316 <        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
317 <        system "$cmd" || die "Failure running rttree_reduce";
318 < } else {
319 <        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
320 <        print "{\n";
321 <        system "$cmd" || die "Failure running rcalc";
322 <        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
323 <                print "0\n";
355 >        # Only output one transmitted anisotropic distribution, preferring backwards
356 >        if ( !$forw || !$doback || $tensortree==3 ) {
357 >                my $ttyp = ("tb","tf")[$forw];
358 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
359 >                if ( $docolor ) {
360 >                        ttree_comp($ttyp, "CIE-u", $transdat, ($tbx,$tfx)[$forw]);
361 >                        ttree_comp($ttyp, "CIE-v", $transdat, ($tbz,$tfz)[$forw]);
362 >                }
363          }
364 <        print "}\n";
365 < }
366 < print
367 < '                       </ScatteringData>
368 <                </WavelengthDataBlock>
369 <        </WavelengthData>
370 < ';
364 >        # Output reflection
365 >        my $rtyp = ("rb","rf")[$forw];
366 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
367 >        if ( $docolor ) {
368 >                ttree_comp($rtyp, "CIE-u", $refldat, ($rbx,$rfx)[$forw]);
369 >                ttree_comp($rtyp, "CIE-v", $refldat, ($rbz,$rfz)[$forw]);
370 >        }
371   }       # end of ttree_out()
372  
373 + # Call rttree_reduce on the given component
374 + sub ttree_comp {
375 +        my $typ = shift;
376 +        my $spec = shift;
377 +        my $src = shift;
378 +        my $dest = shift;
379 +        my $cmd;
380 +        if ($windoz) {
381 +                if ("$spec" eq "Visible") {
382 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
383 +                                q{-e "Ri=$1;Gi=$2;Bi=$3" } .
384 +                                qq{-e "$CIEuv" } .
385 +                                q{-e "$1=Yi/Omega"};
386 +                } elsif ("$spec" eq "CIE-u") {
387 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
388 +                                qq{-e "$CIEuv" } .
389 +                                q{-e "$1=uprime"};
390 +                } elsif ("$spec" eq "CIE-v") {
391 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
392 +                                qq{-e "$CIEuv" } .
393 +                                q{-e "$1=vprime"};
394 +                }
395 +        } else {
396 +                if ("$spec" eq "Visible") {
397 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
398 +                                q{-e 'Ri=$1;Gi=$2;Bi=$3' } .
399 +                                "-e '$CIEuv' " .
400 +                                q{-e '$1=Yi/Omega'};
401 +                } elsif ("$spec" eq "CIE-u") {
402 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
403 +                                "-e '$CIEuv' " .
404 +                                q{-e '$1=uprime'};
405 +                } elsif ("$spec" eq "CIE-v") {
406 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
407 +                                "-e '$CIEuv' " .
408 +                                q{-e '$1=vprime'};
409 +                }
410 +        }
411 +        if ($pctcull >= 0) {
412 +                my $avg = ( "$typ" =~ /^r[fb]/ ) ? " -a" : "";
413 +                my $pcull = ("$spec" eq "Visible") ? $pctcull :
414 +                                                     (100 - (100-$pctcull)*.25) ;
415 +                if ($windoz) {
416 +                        $cmd = "rcollate -ho -oc 1 $src | " .
417 +                                        $cmd .
418 +                                        " | rttree_reduce$avg -h -fa -t $pcull -r $tensortree -g $ttlog2";
419 +                } else {
420 +                        $cmd .= " -of $src " .
421 +                                        "| rttree_reduce$avg -h -ff -t $pcull -r $tensortree -g $ttlog2";
422 +                }
423 +                # print STDERR "Running: $cmd\n";
424 +                system "$cmd > $dest";
425 +                die "Failure running rttree_reduce" if ( $? );
426 +        } else {
427 +                if ($windoz) {
428 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
429 +                } else {
430 +                        $cmd .= " $src";
431 +                }
432 +                open(DATOUT, "> $dest");
433 +                print DATOUT "{\n";
434 +                close DATOUT;
435 +                # print STDERR "Running: $cmd\n";
436 +                system "$cmd >> $dest";
437 +                die "Failure running rcalc" if ( $? );
438 +                open(DATOUT, ">> $dest");
439 +                for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
440 +                        print DATOUT "0\n";
441 +                }
442 +                print DATOUT "}\n";
443 +                close DATOUT;
444 +        }
445 +        if ( "$spec" ne "$curspec" ) {
446 +                $wrapper .= " -s $spec";
447 +                $curspec = $spec;
448 +        }
449 +        $wrapper .= " -$typ $dest";
450 + }       # end of ttree_comp()
451 +
452   #------------- End of do_tree_bsdf() & subroutines -------------#
453  
454   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
455   sub do_matrix_bsdf {
456 < # Set up sampling of portal
457 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
458 < $tcal = '
459 < DEGREE : PI/180;
460 < sq(x) : x*x;
461 < Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
462 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
463 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
464 < Kmax : Kaccum(Knaz(0));
465 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
466 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
467 < Kcol = Kbin - Kaccum(Krow-1);
468 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
469 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
470 < sin_kpol = sin(Kpol);
471 < Dx = cos(Kazi)*sin_kpol;
472 < Dy = sin(Kazi)*sin_kpol;
473 < Dz = sqrt(1 - sin_kpol*sin_kpol);
474 < KprojOmega = PI * if(Kbin-.5,
475 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
476 <        1 - sq(cos(Kpola(1)*DEGREE)));
477 < ';
478 < # Compute Klems bin from exiting ray direction (forward or backward)
479 < $kcal = '
480 < DEGREE : PI/180;
481 < abs(x) : if(x, x, -x);
482 < Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
483 < posangle(a) : if(-a, a + 2*PI, a);
484 < Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
485 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
486 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
369 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
370 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
371 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
372 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
373 < kbin2(pol,azi) = select(kfindrow(1, pol),
374 <                kazn(azi,360/knaz(1)),
375 <                kaccum(1) + kazn(azi,360/knaz(2)),
376 <                kaccum(2) + kazn(azi,360/knaz(3)),
377 <                kaccum(3) + kazn(azi,360/knaz(4)),
378 <                kaccum(4) + kazn(azi,360/knaz(5)),
379 <                kaccum(5) + kazn(azi,360/knaz(6)),
380 <                kaccum(6) + kazn(azi,360/knaz(7)),
381 <                kaccum(7) + kazn(azi,360/knaz(8)),
382 <                kaccum(8) + kazn(azi,360/knaz(9))
383 <        );
384 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
385 < ';
386 < my $ndiv = 145;
387 < # Compute scattering data using rcontrib
388 < my @tfarr;
389 < my @rfarr;
390 < my @tbarr;
391 < my @rbarr;
392 < my $cmd;
393 < my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
394 <        "-e '$kcal' -b kbin -bn $ndiv " .
395 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
396 < my $rccmd = "rcalc -e '$tcal' " .
397 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
398 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
399 < if ( $doforw ) {
400 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
401 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
402 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
403 <        "-e 'zp:$dim[4]' " .
404 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
405 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
406 <        "| $rtcmd";
407 < system "$cmd" || die "Failure running: $cmd\n";
408 < @tfarr = `$rccmd $td/$fmodnm.flt`;
409 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
410 < chomp(@tfarr);
411 < @rfarr = `$rccmd $td/$bmodnm.flt`;
412 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
413 < chomp(@rfarr);
414 < }
415 < if ( $doback ) {
416 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
417 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
418 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
419 <        "-e 'zp:$dim[5]' " .
420 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
421 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
422 <        "| $rtcmd";
423 < system "$cmd" || die "Failure running: $cmd\n";
424 < @tbarr = `$rccmd $td/$bmodnm.flt`;
425 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
426 < chomp(@tbarr);
427 < @rbarr = `$rccmd $td/$fmodnm.flt`;
428 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
429 < chomp(@rbarr);
430 < }
431 < # Output angle basis
432 < print
433 < '       <DataDefinition>
434 <                <IncidentDataStructure>Columns</IncidentDataStructure>
435 <                <AngleBasis>
436 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
437 <                        <AngleBasisBlock>
438 <                        <Theta>0</Theta>
439 <                        <nPhis>1</nPhis>
440 <                        <ThetaBounds>
441 <                                <LowerTheta>0</LowerTheta>
442 <                                <UpperTheta>5</UpperTheta>
443 <                        </ThetaBounds>
444 <                        </AngleBasisBlock>
445 <                        <AngleBasisBlock>
446 <                        <Theta>10</Theta>
447 <                        <nPhis>8</nPhis>
448 <                        <ThetaBounds>
449 <                                <LowerTheta>5</LowerTheta>
450 <                                <UpperTheta>15</UpperTheta>
451 <                        </ThetaBounds>
452 <                        </AngleBasisBlock>
453 <                        <AngleBasisBlock>
454 <                        <Theta>20</Theta>
455 <                        <nPhis>16</nPhis>
456 <                        <ThetaBounds>
457 <                                <LowerTheta>15</LowerTheta>
458 <                                <UpperTheta>25</UpperTheta>
459 <                        </ThetaBounds>
460 <                        </AngleBasisBlock>
461 <                        <AngleBasisBlock>
462 <                        <Theta>30</Theta>
463 <                        <nPhis>20</nPhis>
464 <                        <ThetaBounds>
465 <                                <LowerTheta>25</LowerTheta>
466 <                                <UpperTheta>35</UpperTheta>
467 <                        </ThetaBounds>
468 <                        </AngleBasisBlock>
469 <                        <AngleBasisBlock>
470 <                        <Theta>40</Theta>
471 <                        <nPhis>24</nPhis>
472 <                        <ThetaBounds>
473 <                                <LowerTheta>35</LowerTheta>
474 <                                <UpperTheta>45</UpperTheta>
475 <                        </ThetaBounds>
476 <                        </AngleBasisBlock>
477 <                        <AngleBasisBlock>
478 <                        <Theta>50</Theta>
479 <                        <nPhis>24</nPhis>
480 <                        <ThetaBounds>
481 <                                <LowerTheta>45</LowerTheta>
482 <                                <UpperTheta>55</UpperTheta>
483 <                        </ThetaBounds>
484 <                        </AngleBasisBlock>
485 <                        <AngleBasisBlock>
486 <                        <Theta>60</Theta>
487 <                        <nPhis>24</nPhis>
488 <                        <ThetaBounds>
489 <                                <LowerTheta>55</LowerTheta>
490 <                                <UpperTheta>65</UpperTheta>
491 <                        </ThetaBounds>
492 <                        </AngleBasisBlock>
493 <                        <AngleBasisBlock>
494 <                        <Theta>70</Theta>
495 <                        <nPhis>16</nPhis>
496 <                        <ThetaBounds>
497 <                                <LowerTheta>65</LowerTheta>
498 <                                <UpperTheta>75</UpperTheta>
499 <                        </ThetaBounds>
500 <                        </AngleBasisBlock>
501 <                        <AngleBasisBlock>
502 <                        <Theta>82.5</Theta>
503 <                        <nPhis>12</nPhis>
504 <                        <ThetaBounds>
505 <                                <LowerTheta>75</LowerTheta>
506 <                                <UpperTheta>90</UpperTheta>
507 <                        </ThetaBounds>
508 <                        </AngleBasisBlock>
509 <                </AngleBasis>
510 <        </DataDefinition>
511 < ';
512 < if ( $doforw ) {
513 < print
514 < '       <WavelengthData>
515 <                <LayerNumber>System</LayerNumber>
516 <                <Wavelength unit="Integral">Visible</Wavelength>
517 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
518 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
519 <                <WavelengthDataBlock>
520 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
521 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
522 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
523 <                        <ScatteringDataType>BTDF</ScatteringDataType>
524 <                        <ScatteringData>
525 < ';
526 < # Output front transmission (transposed order)
527 < for (my $od = 0; $od < $ndiv; $od++) {
528 <        for (my $id = 0; $id < $ndiv; $id++) {
529 <                print $tfarr[$ndiv*$id + $od], ",\n";
456 >
457 >        # Run rfluxmtx processes to compute each side
458 >        do_matrix_dir(0) if ( $doback );
459 >        do_matrix_dir(1) if ( $doforw );
460 >
461 > }       # end of sub do_matrix_bsdf()
462 >
463 > # Call rfluxmtx and process tensor tree BSDF for the given direction
464 > sub do_matrix_dir {
465 >        my $forw = shift;
466 >        my $r = do_phase();
467 >        if (!$r) { return; }
468 >        $r = ($r < 0) ? " -r" : "";
469 >        my $cmd;
470 >        my $sender = ($bsender,$fsender)[$forw];
471 >        $cmd = "$rfluxmtx$r -fd $sender $receivers -i $octree";
472 >        # print STDERR "Starting: $cmd\n";
473 >        system $cmd;
474 >        die "Failure running rfluxmtx" if ( $? );
475 >        matrix_out($forw);
476 > }       # end of do_matrix_dir()
477 >
478 > sub matrix_out {
479 >        my $forw = shift;
480 >        my ($refldat,$transdat);
481 >        if ( $forw ) {
482 >                $transdat = $facedat;
483 >                $refldat = $behinddat;
484 >        } else {
485 >                $transdat = $behinddat;
486 >                $refldat = $facedat;
487          }
488 <        print "\n";
489 < }
490 < print
491 < '                       </ScatteringData>
492 <                </WavelengthDataBlock>
493 <        </WavelengthData>
537 <        <WavelengthData>
538 <                <LayerNumber>System</LayerNumber>
539 <                <Wavelength unit="Integral">Visible</Wavelength>
540 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
541 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
542 <                <WavelengthDataBlock>
543 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
544 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
545 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
546 <                        <ScatteringDataType>BTDF</ScatteringDataType>
547 <                        <ScatteringData>
548 < ';
549 < # Output front reflection (transposed order)
550 < for (my $od = 0; $od < $ndiv; $od++) {
551 <        for (my $id = 0; $id < $ndiv; $id++) {
552 <                print $rfarr[$ndiv*$id + $od], ",\n";
488 >        # Output transmission
489 >        my $ttyp = ("tb","tf")[$forw];
490 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
491 >        if ( $docolor ) {
492 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
493 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
494          }
495 <        print "\n";
496 < }
497 < print
498 < '                       </ScatteringData>
499 <                </WavelengthDataBlock>
500 <        </WavelengthData>
560 < ';
561 < }
562 < if ( $doback ) {
563 < print
564 < '       <WavelengthData>
565 <                <LayerNumber>System</LayerNumber>
566 <                <Wavelength unit="Integral">Visible</Wavelength>
567 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
568 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
569 <                <WavelengthDataBlock>
570 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
571 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
572 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
573 <                        <ScatteringDataType>BTDF</ScatteringDataType>
574 <                        <ScatteringData>
575 < ';
576 < # Output back transmission (transposed order)
577 < for (my $od = 0; $od < $ndiv; $od++) {
578 <        for (my $id = 0; $id < $ndiv; $id++) {
579 <                print $tbarr[$ndiv*$id + $od], ",\n";
495 >        # Output reflection
496 >        my $rtyp = ("rb","rf")[$forw];
497 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
498 >        if ( $docolor ) {
499 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
500 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
501          }
502 <        print "\n";
503 < }
504 < print
505 < '                       </ScatteringData>
506 <                </WavelengthDataBlock>
507 <        </WavelengthData>
508 <        <WavelengthData>
509 <                <LayerNumber>System</LayerNumber>
510 <                <Wavelength unit="Integral">Visible</Wavelength>
511 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
512 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
513 <                <WavelengthDataBlock>
514 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
515 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
516 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
596 <                        <ScatteringDataType>BTDF</ScatteringDataType>
597 <                        <ScatteringData>
598 < ';
599 < # Output back reflection (transposed order)
600 < for (my $od = 0; $od < $ndiv; $od++) {
601 <        for (my $id = 0; $id < $ndiv; $id++) {
602 <                print $rbarr[$ndiv*$id + $od], ",\n";
502 > }       # end of matrix_out()
503 >
504 > # Transpose matrix component data and save to file
505 > sub matrix_comp {
506 >        my $typ = shift;
507 >        my $spec = shift;
508 >        my $src = shift;
509 >        my $dest = shift;
510 >        my $cmd = "rmtxop -fa -t";
511 >        if ("$spec" eq "Visible") {
512 >                $cmd .= " -c 0.2651 0.6701 0.0648";
513 >        } elsif ("$spec" eq "CIE-X") {
514 >                $cmd .= " -c 0.5141 0.3239 0.1620";
515 >        } elsif ("$spec" eq "CIE-Z") {
516 >                $cmd .= " -c 0.0241 0.1229 0.8530";
517          }
518 <        print "\n";
519 < }
520 < print
521 < '                       </ScatteringData>
522 <                </WavelengthDataBlock>
523 <        </WavelengthData>
524 < ';
525 < }
526 < }
527 < #------------- End of do_matrix_bsdf() --------------#
518 >        $cmd .= " $src | rcollate -ho -oc 145";
519 >        # print STDERR "Running: $cmd\n";
520 >        system "$cmd > $dest";
521 >        die "Failure running rmtxop" if ( $? );
522 >        if ( "$spec" ne "$curspec" ) {
523 >                $wrapper .= " -s $spec";
524 >                $curspec = $spec;
525 >        }
526 >        $wrapper .= " -$typ $dest";
527 > }       # end of matrix_comp()
528 >
529 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines